org.cpsolver.studentsct.heuristics.selection

## Class CriticalCoursesBranchAndBoundSelection.CriticalCoursesSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection.Selection
  - - org.cpsolver.studentsct.heuristics.selection.CriticalCoursesBranchAndBoundSelection.CriticalCoursesSelection

- Enclosing class:
    CriticalCoursesBranchAndBoundSelection

      public class CriticalCoursesBranchAndBoundSelection.CriticalCoursesSelection
      extends BranchBoundSelection.Selection

- - ### Field Summary

    - ### Fields inherited from class org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection.Selection

      `iAssignment, iBestAssignment, iBestValue, iCurrentAssignment, iStudent, iT0, iT1, iTimeoutReached, iTimesToAvoid, iValues`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CriticalCoursesSelection(Student student, Assignment<Request,Enrollment> assignment)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `backTrack(int idx)` branch & bound search
    `boolean` | `isCritical(int idx)`

    - ### Methods inherited from class org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection.Selection

      `canAssign, canLeaveUnassigned, firstConflict, getAssignmentPenalty, getBestAssignment, getBestNrAssigned, getBestValue, getBound, getBound, getDistanceConflicts, getNrAssigned, getNrAssignedBound, getPenalty, getPenaltyBound, getStudentQualityConflicts, getTime, getTimeOverlappingConflicts, getValue, getWeight, getWeight, inConflict, isTimeoutReached, saveBest, select, values`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CriticalCoursesSelection

          public CriticalCoursesSelection(Student student,
                                          Assignment<Request,Enrollment> assignment)

  - ### Method Detail

    - #### isCritical

          public boolean isCritical(int idx)

    - #### backTrack

          public void backTrack(int idx)

      Description copied from class: `BranchBoundSelection.Selection`
      branch & bound search
      Overrides:
        `backTrack` in class `BranchBoundSelection.Selection`
      Parameters:
        `idx` - index of request